# note: build for raspberrypi
#       autospec --define _with_raspberrypi=1 xbmc.spec
#      -or-
#       rpmbuild --with raspberrypi xbmc.spec

%if "%{?_with_raspberrypi}"
%define pckname  %{name}-rpi
%else
%define pckname  %name
%endif

%define pkgver %(echo %version | cut -d_ -f1)
%define pkgrel %(echo %version | cut -d_ -f2)

%define codenameadd -Jarvis
%define ffmpeg_ver 2.8.6

Name:          kodi
Version:       16.1
Release:       1mamba
Summary:       A media player and entertainment hub for digital media
Group:         Graphical Desktop/Applications/Multimedia
Vendor:        openmamba
Distribution:  openmamba
Packager:      Davide Madrisan <davide.madrisan@gmail.com>
URL:           http://xbmc.org/
Source:        https://github.com/xbmc/xbmc/archive/%{version}%{?codenameadd}.tar.gz
#http://ftp.df.lth.se/pub/xbmc/releases/source/%{version}%{?codenameadd}.tar.gz
Source1:       https://github.com/xbmc/FFmpeg/archive/%{ffmpeg_ver}%{?codenameadd}-%{version}.tar.gz
Patch0:        xbmc-12.0-do_not_require_lsb_release.patch
Patch1:        xbmc-12.0-inconsistent_operand_constraints_in_an_asm.patch
Patch2:        xbmc-12.0-systeminfo.patch
Patch3:        xbmc-12.0-set_native_cxxflags.patch
Patch4:        xbmc-12.0-relax_badcolordepth_check.patch
Patch5:        xbmc-12.0-arm-no-fp.patch
Patch6:        xbmc-13.1-libnfs-1.9.4.patch
Patch7:        kodi-15.2-ffmpeg-x86-asm-impossible-contraints-fix.patch
Patch8:        kodi-16.1-gcc-6.1.0.patch
License:       GPL
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
BuildRequires: libGL-devel
BuildRequires: libGLU-devel
BuildRequires: libSDL2-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libXrandr-devel
BuildRequires: libalsa-devel
BuildRequires: libavahi-devel
BuildRequires: libbluetooth-devel
BuildRequires: libbzip2-devel
BuildRequires: libcap-devel
BuildRequires: libcdio-devel
%ifnarch arm
BuildRequires: libcrystalhd-devel
%endif
BuildRequires: libdbus-devel
BuildRequires: libdcadec-devel
BuildRequires: libdrm-devel
BuildRequires: libexpat-devel
BuildRequires: libfreetype-devel
BuildRequires: libfribidi-devel
BuildRequires: libgcc
BuildRequires: libgcrypt-devel
BuildRequires: libglew-devel
BuildRequires: libglib-devel
BuildRequires: libgmp-devel
BuildRequires: libgnutls-devel
BuildRequires: libgpg-error-devel
BuildRequires: libjasper-devel
BuildRequires: libjpeg-devel
BuildRequires: liblzma-devel
BuildRequires: liblzo-devel
BuildRequires: libmicrohttpd-devel
BuildRequires: libmysqlclient-devel
BuildRequires: libnettle-devel
BuildRequires: libogg-devel
BuildRequires: libopenssl-devel
BuildRequires: libp11-kit-devel
BuildRequires: libpcre-devel
BuildRequires: libpng-devel
BuildRequires: libpulseaudio-devel
BuildRequires: libpython27-devel
BuildRequires: libsmbclient-devel
BuildRequires: libsqlite-devel
BuildRequires: libssh-devel
BuildRequires: libstdc++6-devel
BuildRequires: libtag-devel
BuildRequires: libtasn1-devel
BuildRequires: libtiff-devel
BuildRequires: libtinyxml-devel
BuildRequires: libudev-devel
BuildRequires: libuuid-devel
BuildRequires: libva-devel
BuildRequires: libvorbis-devel
BuildRequires: libxcb-devel
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: libyajl-devel
BuildRequires: libz-devel
BuildRequires: trousers-devel
## AUTOBUILDREQ-END
BuildRequires: doxygen
BuildRequires: gperf
BuildRequires: nasm
BuildRequires: swig
BuildRequires: unzip
BuildRequires: java-gcj-compat-runtime
BuildRequires: libalsa-devel
BuildRequires: libass-devel
BuildRequires: libbluray-devel
BuildRequires: libcurl-devel
BuildRequires: libdvdcss-devel
BuildRequires: libflac-devel
BuildRequires: libGLESv2-devel
BuildRequires: liblame-devel
BuildRequires: libmad-devel
BuildRequires: libmodplug-devel
BuildRequires: libmpeg2-devel
BuildRequires: libogg-devel
BuildRequires: librtmp-devel
BuildRequires: libpostproc-ffmpeg-devel
BuildRequires: libSDL-devel
BuildRequires: libSDL_gfx-devel
BuildRequires: libSDL_image-devel
BuildRequires: libtag-devel >= 1.8
BuildRequires: libusb-devel
BuildRequires: libvorbis-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libXrandr-devel
BuildRequires: libzip-devel
%if "%{?_with_raspberrypi}"
BuildRequires: libraspberrypi-devel
%endif
BuildRequires: libcec-devel
BuildRequires: libprojectM-devel
BuildRequires: libnfs-devel
BuildRequires: libdcadec-devel
BuildRequires: libcrossguid-devel
Requires:      mesa-tests
Requires:      xdpyinfo
Requires:      libprojectM
Provides:      xbmc
Obsoletes:     xbmc
BuildRoot:     %{_tmppath}/%{name}-%{version}-root

%description
XBMC is an award-winning free and open source (GPL) software media player and entertainment hub for digital media.

%package devel
Summary:       Development package for %{name}
Group:         Development/Libraries
Requires:      %{name} = %{version}-%{release}
Provides:      xbmc-devel
Obsoletes:     xbmc-devel

%description devel
XBMC is an award-winning free and open source (GPL) software media player and entertainment hub for digital media.
This package contains headers for %{name} development.

%if "%{?_with_raspberrypi}"
%package -n %{name}-rpi
Summary:       A media player and entertainment hub for digital media
Group:         Graphical Desktop/Applications/Multimedia
Provides:      xbmc-rpi
Obsoletes:     xbmc-rpi

%description -n %{name}-rpi
XBMC is an award-winning free and open source (GPL) software media player and entertainment hub for digital media.
%endif

%prep
%setup -q -n xbmc-%{pkgver}%{?codenameadd}
#-D -T
#:<< ___EOF
#%patch0 -p1
#%patch1 -p1
#%patch2 -p1
%if "%{?_with_raspberrypi}"
%patch3 -p1
%patch4 -p1
%endif
#%patch5 -p1
#%patch6 -p1
%patch8 -p1

ln -s %{SOURCE1} tools/depends/target/ffmpeg/

%ifarch %{ix86}
cd tools/depends/target/ffmpeg/
tar xf %{ffmpeg_ver}%{?codenameadd}-%{version}.tar.gz
cd FFmpeg-%{ffmpeg_ver}%{?codenameadd}-%{version}
%patch7 -p1
%endif

%build
#:<< ___EOF
./bootstrap

%if "%{?_with_raspberrypi}"
# -Wno-psabi: just to avoid the annoying flooding of gcc warnings
#   "the mangling of ‘va_list’ has changed in GCC 4.4"
# We cannot use pipes rather than intermediate files ('-pipe') because
#   this option requires too much memory and the build will end with an error
#   (xbmc/music/MusicDatabase.o -- Error: unknown pseudo-op: '.uleb')
BUILD_FLAGS="\
-O2 -fomit-frame-pointer -Wno-psabi \
-lvchostif \
-I/opt/vc/include \
-I/opt/vc/include/IL \
-I/opt/vc/include/interface/vcos/pthreads \
-I/opt/vc/include/interface/vmcs_host/linux"

export CXXFLAGS="$BUILD_FLAGS"
export LDFLAGS="$LDFLAGS -L/opt/vc/lib"
%endif

%configure \
   --disable-debug \
%if "%{?_with_raspberrypi}"
   --with-platform=raspberry-pi \
   --enable-gles \
   --disable-joystick \
   --disable-sdl \
   --disable-x11 \
   --disable-xrandr \
   --disable-openmax \
   --disable-afpclient \
   --disable-crystalhd \
   --disable-vaapi \
   --disable-vdpau \
   --disable-vtbdecoder \
   --enable-player=omxplayer \
%else
   --enable-shared-libraries \
%endif
%ifarch arm
   --disable-vaapi \
   --disable-vdpau \
%endif
   --enable-shared \
   --enable-pulse \
   --disable-hal \
   --enable-optical-drive \
   --enable-libcec
#  --disable-dvdcss

___EOF

%make

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
%makeinstall
rm -fr %{buildroot}%{_datadir}/doc

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%pre
if [ $1 -ge 1 ]; then
   [ -L %{_libdir}/xbmc ] || rm -rf %{_libdir}/xbmc
fi
exit 0

%post -n %{pckname}
/bin/touch --no-create %{_datadir}/icons/hicolor >/dev/null 2>&1
exit 0

%postun -n %{pckname}
if [ $1 -eq 0 ] ; then
   /bin/touch --no-create %{_datadir}/icons/hicolor >/dev/null 2>&1
   /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor >/dev/null 2>&1
fi
exit 0

%posttrans -n %{pckname}
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor >/dev/null 2>&1
exit 0

%files -n %{pckname}
%defattr(-,root,root)
%{_bindir}/xbmc
%{_bindir}/xbmc-standalone
%{_bindir}/kodi
%{_bindir}/kodi-standalone
%{_datadir}/xbmc
%dir %{_datadir}/kodi
%{_datadir}/kodi/*
%attr(0644,root,root) %{_datadir}/applications/kodi.desktop
%{_datadir}/xsessions/kodi.desktop
%{_datadir}/xsessions/xbmc.desktop
%{_datadir}/icons/hicolor/*/*/*.png
%{_libdir}/xbmc
%dir %{_libdir}/kodi
%{_libdir}/kodi/*
%doc docs
%doc copying.txt LICENSE.GPL

%files devel
%defattr(-,root,root)
%dir %{_includedir}/xbmc
%{_includedir}/xbmc/*
%dir %{_includedir}/kodi
%{_includedir}/kodi/*
#%doc README

%changelog
* Thu May 19 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 16.1-1mamba
- update to 16.1

* Mon Mar 14 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 16.0-1mamba
- update to 16.0

* Sun Feb 14 2016 Silvan Calarco <silvan.calarco@mambasoft.it> 15.2-3mamba
- rebuilt with gcc 5.3.0

* Wed Nov 18 2015 Silvan Calarco <silvan.calarco@mambasoft.it> 15.2-2mamba
- fix kodi vs xbmc libdir weirdness

* Sun Nov 15 2015 Automatic Build System <autodist@mambasoft.it> 15.2-1mamba
- automatic version update by autodist

* Tue Sep 22 2015 Silvan Calarco <silvan.calarco@mambasoft.it> 15.1-1mamba
- update to 15.1

* Fri Sep 19 2014 Automatic Build System <autodist@mambasoft.it> 13.2-1mamba
- automatic update by autodist

* Mon Jun 23 2014 Automatic Build System <autodist@mambasoft.it> 13.1-1mamba
- automatic update by autodist

* Wed Jun 04 2014 Automatic Build System <autodist@mambasoft.it> 13.0_r2-1mamba
- automatic update by autodist

* Sat Jan 04 2014 Automatic Build System <autodist@mambasoft.it> 12.3-1mamba
- automatic version update by autodist

* Sat Jun 01 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 12.2-2mamba
- python 2.7 mass rebuild

* Tue May 07 2013 Automatic Build System <autodist@mambasoft.it> 12.2-1mamba
- automatic version update by autodist

* Tue Mar 26 2013 Automatic Build System <autodist@mambasoft.it> 12.1-1mamba
- automatic version update by autodist

* Sat Mar 09 2013 Silvan Calarco <silvan.calarco@mambasoft.it> 12.0-4mamba
- require libprojectM
- raspberrypi: don't disable libprojectM

* Mon Feb 25 2013 openmamba WebBuild System <webbuild@openmamba.org> 12.0-3mamba
- - simplify the conditional statements by using a syntax that autospec can understand

* Sun Feb 24 2013 openmamba WebBuild System <webbuild@openmamba.org> 12.0-2mamba
- make raspberrypi a conditional build target

* Fri Feb 15 2013 Davide Madrisan <davide.madrisan@gmail.com> 12.0-1mamba
- package created by autospec
